<?php

if (!$GLOBALS['loader_on']) { //check if file was loaded correctly
  die("ERROR: File loaded directly without an allowed loader!");
}

if (!$GLOBALS['logged_in']) { //Check if user is logged in. If not, something is wrong!
  die("ERROR: This operation cannot be done when the user isn't logged in!");
}

//------------------- ----- ---- --- -- -

if (get_magic_quotes_gpc()) { //If magic quotes is on
  foreach ($_POST as $name => $value) { //strip escape slashes (\)
    $_POST[$name] = stripslashes($value);
  }
}

if ((!$_POST['url']) && ($_POST['submit'] != "Ta bort lnk")) {
  print "
<div style='min-width: 750px;'>
<p>
You have to supply an URL!
</p>
<a href='javascript:history.go(-1);'>Go back</a>
</div>
</p><p>";
} else {
  switch ($_POST['submit']) {
    case "Save link":
      $keep = true;
      foreach ($_POST as $name => $value) { //reassign $_POST['*'] as $l_* (link info)
        $name = "l_".$name;
        if (!is_numeric($value)) {
          $$name = htmlspecialchars(stripslashes($value), ENT_QUOTES); //ugh...
        } else {
          $$name = $value;
        }
      }
      $l_username = $_SESSION['username'];
    case "Remove link":
      $l_id = $_POST['id'];
      print "
<div style='min-width: 750px;'>
<form action='$self' method='POST'>";
      if (is_numeric($l_id)) {
        print "
<input type='hidden' name='id' value='$l_id'>";
        if (!$keep) {
          print "
<input type='hidden' name='action' value='del'>
<span style='font-size: 14pt; font-weight: bold;'>You are about to <u><i>irreversibly</i></u> remove the following link:</span>
</p><p>";
          $link = dbQuery("SELECT url,title,comment,category,username FROM $mysql_table_links LEFT JOIN $mysql_table_users ON uid=user WHERE id='$l_id' LIMIT 1", $db, -2, 2);
          if ($link) {
            foreach ($link as $name => $value) { //reassign link data as $l_fieldname
              $name = "l_".$name;
              $$name = $value;
            }
          }
          unset($link);
        } else {
          print "
<input type='hidden' name='action' value='edit'>";
        }
      }
      $l_catname = dbQuery("SELECT catname FROM $mysql_table_categories WHERE cid='$l_category'", $db, 0, 2);
      print "
<input type='hidden' name='url' value='$l_url'>
<input type='hidden' name='title' value='$l_title'>
<input type='hidden' name='comment' value='$l_comment'>
<input type='hidden' name='category' value='$l_category'>
<table border='0' cellspacing='1' cellpadding='3' width='100%' class='tb'>
<tr align='center' class='th'>
<td>URL</td><td>Title</td><td>Comment</td><td>Category</td><td>By</td>
</tr><tr align='center'>
<td><a href='".htmlspecialchars($l_url, ENT_QUOTES)."' target='_new'>$l_url</a></td>
<td>$l_title</td>
<td align='left'>".nl2br($l_comment)."</td>
<td>".($l_catname ? $l_catname : "No category")."</td>
<td>$l_username</td>
</tr>
</table>
</p><p>
<div align='center'>
<b>Is this correct?</b><br>
<input style='color: #00AA00; font-weight: bold;' type='submit' name='submit' value='[   Yes   ]'>
<input style='color: #AA0000; font-weight: bold;' type='button' value='[   No   ]' onClick='javascript:history.go(-1);'>";
      if (($keep) && (strpos(strtolower($l_url),"http://") !== 0)
         && (strpos(strtolower($l_url),"https://") !== 0)
         && (strpos(strtolower($l_url),"ftp://") !== 0)) {
        print"
</p><p>
<b>WARNING!</b> \"http://\", \"https://\" or \"ftp://\" was not found at the start of the link! You should check the link (click on it, it will open in a new window) so that it really is correct!";
      }
      print "
</div>
</form>
</div>
";
    break;
    case "[   Yes   ]":
      foreach ($_POST as $name => $value) { //reassign $_POST['*'] as $p_*
        $name = "p_".$name;
        if (!is_numeric($value)) {
          $$name = dbEscape($value);
        } else {
          $$name = $value;
        }
      }
      $u_id = dbEscape($_SESSION['id']);
      if (is_numeric($p_id)) {
        if ($p_action == "edit") {
          $query = "UPDATE $mysql_table_links SET user='$u_id',category='$p_category',url='$p_url',title='$p_title',comment='$p_comment' WHERE id='$p_id' LIMIT 1";
        } elseif ($p_action == "del") {
          $query = "DELETE FROM $mysql_table_links WHERE id='$p_id' LIMIT 1";
        } else {
          die("ERROR: A link ID was specified in the POST data, but no action!");
        }
      } else {
        $query = "INSERT INTO $mysql_table_links (user,category,url,title,comment) VALUES ('$u_id','$p_category','$p_url','$p_title','$p_comment')";
      }
      print "
<div style='min-width: 750px;'>";
      if (dbQuery($query, $db, -3, 1)) {
        print "
Link ".(is_numeric($p_id) ? ($p_action == "del" ? "removed from" : "edited in") : "saved in")." the database.";
      }
      print "
</p><p>
<a href='$self'>Go back</a>
</div>";
    break;
  }
}

?>