<?php

if (!$GLOBALS['loader_on']) { //check if file was loaded correctly
  die("ERROR: File loaded directly without an allowed loader!");
}

if (!$GLOBALS['logged_in']) { //Check if user is logged in. If not, something is wrong!
  die("ERROR: This operation cannot be done when the user isn't logged in!");
}

//------------------- ----- ---- --- -- -

if (get_magic_quotes_gpc()) { //If magic quotes is on
  foreach ($_POST as $name => $value) { //strip escape slashes (\)
    $_POST[$name] = stripslashes($value);
  }
}

$error = true; //Somewhat pessimistic.
$reserved_catnames = array("No category", "All categories", "---------------", "Links without category");

switch ($_POST['submit']) {
  case "Create category":
  case "Rename category":
    if ($_POST['catname']) {
      $e_catname = dbEscape($_POST['catname']);
      if ((!in_array($_POST['catname'], $reserved_catnames)) && (dbQuery("SELECT catname FROM $mysql_table_categories WHERE catname='$e_catname' LIMIT 1", $db, 0, 2) != $_POST['catname'])) {
        if ($_POST['submit'] == "Create category") {
          if (dbQuery("INSERT INTO $mysql_table_categories (catname) VALUES ('$e_catname')", $db, -3, 1)) {
            $error = false;
            print "
Category \"".$_POST['catname']."\" created.";
          }
        } elseif ($_POST['submit'] == "Rename category") {
          $e_catid = dbEscape($_POST['catid']);
          if (dbQuery("UPDATE $mysql_table_categories SET catname='$e_catname' WHERE cid='$e_catid' LIMIT 1", $db, -3, 1)) {
            $error = false;
            print "
Category renamed to \"".$_POST['catname']."\".";
          }
        }
      } else {
        print "
There is either already a category named \"".$_POST['catname']."\" or that caregory name is reserved!";
      }
    } else {
      print "
Category names must contain at least one character!";
    }
  break;
  case "Delete category":
    if ($_POST['catid'] != $_POST['newid']) {
      $e_catid = dbEscape($_POST['catid']);
      $e_newid = dbEscape($_POST['newid']);
      if (dbQuery("UPDATE $mysql_table_links SET category='$e_newid' WHERE category='$e_catid'", $db, -3, 1)) {
        print "
Links moved to new category.
<p></p>";
        if (dbQuery("DELETE FROM $mysql_table_categories WHERE cid='$e_catid' LIMIT 1", $db, -3, 1)) {
          $error = false;
          print "
Category deleted.";
        }
      }
    } else {
      print "
You can't move links to the category that will be deleted!
</p><p>";
    }
  break;
}

print "
</p><p>
<a href='".($error ? "javascript: history.go(-1);" : "admin.php")."'>Go back</a>";

?>